com.io7m.r2.core

## Interface R2GeometryBufferUsableType

- All Superinterfaces:
    com.io7m.jcanephora.core.JCGLResourceSizedType, com.io7m.jcanephora.core.JCGLResourceUsableType, R2RenderTargetUsableType<R2GeometryBufferDescriptionType>
  All Known Subinterfaces:
    R2GeometryBufferType
  All Known Implementing Classes:
    R2GeometryBuffer

      public interface R2GeometryBufferUsableType
      extends R2RenderTargetUsableType<R2GeometryBufferDescriptionType>

  The type of usable geometry buffers.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `R2Texture2DUsableType` | `albedoEmissiveTexture()`
    `R2Texture2DUsableType` | `depthTexture()`
    `default R2Texture2DUsableType` | `getSpecularTextureOrDefault(R2TextureDefaultsType td)` Return either the allocated specular texture, or a suitable default replacement that behaves as if the geometry buffer contains no specular components.
    `R2Texture2DUsableType` | `normalTexture()`
    `Optional<R2Texture2DUsableType>` | `specularTexture()`

    - ### Methods inherited from interface com.io7m.r2.core.R2RenderTargetUsableType

      `area, clearBoundPrimaryFramebuffer, description, primaryFramebuffer`

    - ### Methods inherited from interface com.io7m.jcanephora.core.JCGLResourceUsableType

      `isDeleted`

    - ### Methods inherited from interface com.io7m.jcanephora.core.JCGLResourceSizedType

      `getRange`

- - ### Method Detail

    - #### albedoEmissiveTexture

          R2Texture2DUsableType albedoEmissiveTexture()

      Returns:
        The albedo/emissive texture

    - #### normalTexture

          R2Texture2DUsableType normalTexture()

      Returns:
        The normal texture

    - #### specularTexture

          Optional<R2Texture2DUsableType> specularTexture()

      Returns:
        The specular texture

    - #### getSpecularTextureOrDefault

          default R2Texture2DUsableType getSpecularTextureOrDefault(R2TextureDefaultsType td)

      Return either the allocated specular texture, or a suitable default replacement that behaves as if the geometry buffer contains no specular components.
      Parameters:
        `td` - The texture defaults
      Returns:
        A specular texture, or a default replacement

    - #### depthTexture

          R2Texture2DUsableType depthTexture()

      Returns:
        The depth/stencil texture

Copyright © 2016 <code@io7m.com> http://io7m.com